-- Copyright © 2008, 2009 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.
-- Current distribution permissions only include curse.com, wowui.worldofwar.net, wowinterface.com and their respective addon updaters


local TotemTimers = TotemTimers

local function GetSpellTab(tab)
    local _, _, offset, numSpells = GetSpellTabInfo(tab)
    local AvailableSpells = TotemTimers.AvailableSpells
    for s = offset + 1, offset + numSpells do 
        local spelltype, spell = GetSpellBookItemInfo(s, BOOKTYPE_SPELL)
        if spell == TotemTimers.SpellIDs.StormStrike then print(spelltype) end
        if spelltype == "SPELL" then print(GetSpellInfo(spell))
            AvailableSpells[spell] = true
        end
    end
end    


function TotemTimers.GetSpells()
    local AvailableSpells = TotemTimers.AvailableSpells
    wipe(AvailableSpells)
    for _,s in pairs(TotemTimers.SpellIDs) do
        AvailableSpells[s] = IsSpellKnown(s)
    end
    if AvailableSpells[TotemTimers.SpellIDs.PrimalStrike] and UnitLevel("player") > 10 then
        AvailableSpells[TotemTimers.SpellIDs.StormStrike] = true
    end
    return true
end

--[[function TotemTimers.GetTalents()
    wipe(TotemTimers.AvailableTalents)
    if select(5, GetTalentInfo(2,17))>0 then TotemTimers.AvailableTalents.Maelstrom = true end
    if select(5, GetTalentInfo(1,18))>0 then TotemTimers.AvailableTalents.LavaSurge = true end
    if select(5, GetTalentInfo(1,13))>0 then TotemTimers.AvailableTalents.Fulmination = true end
end]]


function TotemTimers.LearnedSpell(spell,tab)
    if spell then
        TotemTimers.AvailableSpells[spell] = true
    elseif tab then
        GetSpellTab(tab)
    else
        TotemTimers.GetSpells()
    end
    TotemTimers.SetCastButtonSpells()
    TotemTimers.SetWeaponTrackerSpells()
    TotemTimers.ProcessSetting("AnkhTracker")
    TotemTimers.ProcessSetting("ShieldTracker")
    TotemTimers.ProcessSetting("EarthShieldTracker")
    TotemTimers.ProcessSetting("WeaponTracker")  
    TotemTimers.ProcessSetting("EnhanceCDs") 
    TotemTimers.ProcessSetting("Show")
    TotemTimers.ProgramSetButtons()
    TotemTimers.ConfigAuras()
end


function TotemTimers.ChangedTalents()
	TotemTimers.GetSpells()
    TotemTimers.SelectActiveProfile()
    TotemTimers.ExecuteProfile()
end
